{"openapi":"3.1.0","info":{"title":"POST /api/v1/businesses/{business_id}/cfo-portal/debt-schedule/instruments/{instrument_id}/covenants","version":"1.0.0","description":"Add a covenant to a debt instrument"},"servers":[{"url":"https://api.ondayzero.com","description":"Production"}],"paths":{"/api/v1/businesses/{business_id}/cfo-portal/debt-schedule/instruments/{instrument_id}/covenants":{"post":{"tags":["cfo-portal"],"summary":"Add a covenant to a debt instrument","description":"Attach a financial covenant to a loan.","operationId":"cfo_portal_create_debt_covenant_api_v1_businesses__business_id__cfo_portal_debt_schedule_instruments__instrument_id__covenants_post","parameters":[{"name":"business_id","in":"path","required":true,"schema":{"type":"string","title":"Business Id"}},{"name":"instrument_id","in":"path","required":true,"schema":{"type":"string","title":"Instrument Id"}},{"name":"authorization","in":"header","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Authorization"}},{"name":"x-business-id","in":"header","required":false,"schema":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"X-Business-Id"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DebtCovenantCreateRequest"}}}},"responses":{"201":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessEnvelope_DebtCovenantResponse_"}}}},"400":{"description":"Bad Request - Invalid input","content":{"application/json":{"example":{"detail":"Invalid request parameters"}}}},"401":{"description":"Unauthorized - Authentication required","content":{"application/json":{"example":{"detail":"Not authenticated"}}}},"403":{"description":"Forbidden - Insufficient permissions","content":{"application/json":{"example":{"detail":"Not enough permissions"}}}},"404":{"description":"Not Found - Resource does not exist","content":{"application/json":{"example":{"detail":"Resource not found"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}}},"components":{"schemas":{"DebtCovenantCreateRequest":{"properties":{"metric_name":{"type":"string","maxLength":100,"minLength":1,"title":"Metric Name"},"operator":{"type":"string","title":"Operator","description":"CovenantOperatorEnum: greater_than, less_than, greater_than_or_equal, less_than_or_equal."},"threshold_value":{"type":"string","maxLength":50,"minLength":1,"title":"Threshold Value"},"measurement_frequency":{"type":"string","title":"Measurement Frequency","description":"PaymentFrequencyEnum cadence for measurement.","default":"quarterly"},"description":{"anyOf":[{"type":"string","maxLength":500},{"type":"null"}],"title":"Description"}},"type":"object","required":["metric_name","operator","threshold_value"],"title":"DebtCovenantCreateRequest","description":"Request payload for attaching a covenant to a debt instrument."},"DebtCovenantResponse":{"properties":{"id":{"type":"string","title":"Id"},"metric_name":{"type":"string","title":"Metric Name"},"operator":{"type":"string","title":"Operator"},"threshold_value":{"type":"string","title":"Threshold Value"},"measurement_frequency":{"type":"string","title":"Measurement Frequency"},"description":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Description"}},"type":"object","required":["id","metric_name","operator","threshold_value","measurement_frequency"],"title":"DebtCovenantResponse","description":"A financial covenant attached to a debt instrument."},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"type":"array","title":"Detail"}},"type":"object","title":"HTTPValidationError"},"SuccessEnvelope_DebtCovenantResponse_":{"properties":{"success":{"type":"boolean","title":"Success","default":true},"message":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Message"},"code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Code"},"data":{"anyOf":[{"$ref":"#/components/schemas/DebtCovenantResponse"},{"type":"null"}]}},"additionalProperties":true,"type":"object","title":"SuccessEnvelope[DebtCovenantResponse]"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"type":"array","title":"Location"},"msg":{"type":"string","title":"Message"},"type":{"type":"string","title":"Error Type"},"input":{"title":"Input"},"ctx":{"type":"object","title":"Context"}},"type":"object","required":["loc","msg","type"],"title":"ValidationError"}},"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"API Token","description":"API token authentication. Format: `Bearer dz_...`"}}},"security":[{"BearerAuth":[]}]}